Index: Thuban/UI/baserenderer.py
===================================================================
RCS file: /thubanrepository/thuban/Thuban/UI/baserenderer.py,v
retrieving revision 1.14
diff -u -r1.14 baserenderer.py
--- Thuban/UI/baserenderer.py	21 Jan 2005 14:01:25 -0000	1.14
+++ Thuban/UI/baserenderer.py	24 Jan 2005 22:54:24 -0000
@@ -29,6 +29,7 @@
      ALIGN_LEFT, ALIGN_RIGHT
 
 import Thuban.Model.resource
+from Thuban.Model.color import Color2hex
 
 if Thuban.Model.resource.has_gdal_support():
     from gdalwarp import ProjectRasterFile
@@ -458,6 +459,7 @@
         # True  -- warp the image to the size of the whole screen
         # False -- only use the bound box of the layer (currently inaccurate)
         if True: 
+        #if False: 
             pmin = [0,height]
             pmax = [width, 0]
         else:
@@ -465,8 +467,14 @@
             bb = [[[bb[0], bb[1]], [bb[2], bb[3]],],]
             pmin, pmax = self.projected_points(layer, bb)[0]
 
-        fmin = [max(0, pmin[0]) - offx, offy - min(height, pmin[1])]
-        fmax = [min(width, pmax[0]) - offx, offy - max(0, pmax[1])]
+        #print bb
+        #print pmin, pmax
+
+        fmin = [max(0, min(pmin[0], pmax[0])) - offx, 
+                offy - min(height, max(pmin[1], pmax[1]))]
+
+        fmax = [min(width, max(pmin[0], pmax[0])) - offx, 
+                offy - max(0, min(pmin[1], pmax[1]))]
 
         xmin = fmin[0]/self.scale
         ymin = fmin[1]/self.scale
@@ -476,21 +484,38 @@
         width  = int(min(width,  round(fmax[0] - fmin[0] + 1)))
         height = int(min(height, round(fmax[1] - fmin[1] + 1)))
 
+        if layer.UseMask():
+            maskColor = layer.MaskColor()
+        else:
+            maskColor = None
+
         try:
-            data = [width, height,
-                    ProjectRasterFile(layer.GetImageFilename(),
-                                     in_proj, out_proj,
-                                     (xmin, ymin, xmax, ymax), "",
-                                     (width, height))
-                   ]
+            #data = None
+
+            maskParam = None
+
+            if maskColor is not None:
+                maskParam = (int(round(maskColor.red   * 255)), 
+                             int(round(maskColor.green * 255)), 
+                             int(round(maskColor.blue  * 255)))
+
+            project_params = (layer.GetImageFilename(), in_proj, out_proj, 
+                              (xmin, ymin, xmax, ymax), "", (width, height),
+                              maskParam)
+
+            data = (width, height, apply(ProjectRasterFile, project_params))
+
         except (IOError, AttributeError, ValueError):
             # Why does this catch AttributeError and ValueError?
             # FIXME: The exception should be communicated to the user
             # better.
             traceback.print_exc()
         else:
-            mask = "#030104"
-            #mask = None
+            if maskColor is not None:
+                mask = Color2hex(maskColor)
+            else:
+                mask = None
+
             self.draw_raster_data(fmin[0]+offx, offy-fmax[1], data, "RAW", mask)
             data = None
 
